function keyPressCallback(obj, src, evt)

    KEY_MOV_LEFT = "a";
    KEY_MOV_RIGHT = "d";
    KEY_MOV_UP = "w";
    KEY_MOV_DOWN = "s";
    KEY_MOV_FORWARD = "q";
    KEY_MOV_BACKWARD = "e";

    keymov_step_sz = 0.5;

    fprintf("Key %s is pressed.\n", evt.Key);
    
    if obj.ndStatTFFoc.value
        flag_keymov = true;
        if evt.Key == KEY_MOV_LEFT
            mov = [0,-1,0] * keymov_step_sz;
        elseif evt.Key == KEY_MOV_RIGHT
            mov = [0,1,0] * keymov_step_sz;
        elseif evt.Key == KEY_MOV_UP
            mov = [1,0,0] * keymov_step_sz;
        elseif evt.Key == KEY_MOV_DOWN
            mov = [-1,0,0] * keymov_step_sz;
        elseif evt.Key == KEY_MOV_FORWARD
            mov = [0,0,1] * keymov_step_sz;
        elseif evt.Key == KEY_MOV_BACKWARD
            mov = [0,0,-1] * keymov_step_sz;
        else
            flag_keymov = false;
        end
        
        if flag_keymov
            foc_ind = obj.ndTFFocPtInd.value;
            ori_foc_pos_cyl = obj.cvter_eul2cyl(obj.ndTFFocPt.value);
            new_foc_pos_cyl = ori_foc_pos_cyl(:) + mov(:);
            new_foc_pos = obj.cvter_cyl2eul(new_foc_pos_cyl);
            fila_poses = obj.ndTFNewFilaPts.value;
            fila_poses(:, foc_ind) = new_foc_pos;
    
            obj.ndTFNewFilaPts.updateValue(fila_poses);
            obj.focusOnFilaPoint(foc_ind);
        end
    end

end