function registerAvgNumSpin(obj, spin)
    spin.ValueChangedFcn = @(src, evt)(valueChangedCallback(obj.ndFilaSecAvgNum, src, evt));
    spin.Limits = [1, 30];

    comg.Node.output("Set Filament Section Averaging Number", ...
            @(val)(setSpinValue(spin, val)), ...
            obj.ndFilaSecAvgNum ...
        ).activate();
    
end

function setSpinValue(spin, val)
    spin.Value = val;
end

function valueChangedCallback(ndFilaSecAvgNum, src, evt)
    fprintf('Filament Section Averaged Number value changed from %d to %d.\n', evt.PreviousValue, evt.Value);
    ndFilaSecAvgNum.updateValue(evt.Value);
end

