function registerFilaListBox(obj, list_box)
    list_box.ValueChangedFcn = @(src, evt)(valueChangedCallback(obj.ndFilaEngn, src, evt));
    
    comg.Node.output("Enable Filament-Selecting-Box",...
            @(fila_engine)(enableComponent(list_box, fila_engine)), ...
            obj.ndFilaEngn ...
        ).activate();

    comg.Node.output("Generate Content of Filament-Selecting-Box",...
            @(fila_engine)(generateFilamentList(list_box, fila_engine)), ...
            obj.ndFilaEngn ...
        ).activate();
end

function enableComponent(component, fila_engine)
    flag_enable = fila_engine.allowSelectFilament();
    component.Enable = flag_enable;
end

function generateFilamentList(listbox, fila_engine)
    fila_keys = fila_engine.getAllFilaments();
    if ~isempty(fila_keys)
        listbox.Items = arrayfun(@(n)({['Filament ', num2str(n)]}),fila_keys);
    end

    sel_fila_key = fila_engine.getSelectingFilamentKey();
    if ~isempty(sel_fila_key)
        listbox.Value = ['Filament ', num2str(sel_fila_key)];
    end
end

function valueChangedCallback(ndFilaEngn, src, evt)
    fprintf('Fila box value changed to %s.\n', evt.Value);

    selecting_str = char(evt.Value);
    selecting_key = str2double(selecting_str(10:end));
    ndFilaEngn.value.selectFilament(selecting_key);
    ndFilaEngn.update();
end


