function registerOutRadSpin(obj, spin)
    spin.ValueChangedFcn = @(src, evt)(valueChangedCallback(obj.ndFilaInnRad, obj.ndFilaOutRad, src, evt));
    
    comg.Node.output("Set Filament Outer Radius", ...
            @(val)(setSpinValue(spin, val)), ...
            obj.ndFilaOutRad ...
        ).activate();
end

function setSpinValue(spin, val)
    spin.Value = val;
end

function valueChangedCallback(ndFilaInnRad, ndFilaOutRad, src, evt)
    fprintf('Filament Outer Radius value changed from %d to %d.\n', evt.PreviousValue, evt.Value);

    upder = [];
    if ndFilaInnRad.value > evt.Value
        upder = ndFilaInnRad.updateValue(evt.Value);
    end

    ndFilaOutRad.updateValue(evt.Value, upder);
end
