function registerSaveSurfButton(obj, butt)
    butt.ButtonPushedFcn = @(src, evt)(buttonPushedCallback(obj.ndShowSurf, src, evt));

    comg.Node.output("Enable Save-Surface-Button",...
            @(fila_engine)(enableComponent(butt, fila_engine)), ...
            obj.ndFilaEngn ...
        ).activate();
end

function enableComponent(component, fila_engine)
    flag_enable = fila_engine.inFilamentTuningMode();
    component.Enable = flag_enable;
end

function buttonPushedCallback(ndShowSurf, src, evt)
    fprintf("Save Surface button pushed.\n");
    [filename, pathname] = uiputfile('*.png', 'Save Filament Positions', 'unrolled_surface.png');
    if filename
        imgval = ndShowSurf.value(end:-1:1,:);
        maxval = max(imgval, [], 'all');
        minval = min(imgval, [], 'all');
        imgval = (imgval - minval)/(maxval - minval);
        imwrite(imgval, [pathname, filename]);
    end
end



