function registerSecLenSpin(obj, spin)
    spin.ValueChangedFcn = @(src, evt)(valueChangedCallback(obj.ndFilaSecInd, src, evt));

    comg.Node.output("Set Filament Section Index", ...
            @(extr_fila_rect, secind)(setSpinValue(spin, extr_fila_rect, secind)), ...
            obj.ndExtrFilaRect, obj.ndFilaSecInd ...
        ).activate();
end

function setSpinValue(spin, extr_fila_rect, secind)
    num_sec = size(extr_fila_rect,3);
    if num_sec <= 1
        num_sec = inf;
    end
    spin.Limits = [1,num_sec];
    spin.Value = max(1,min(num_sec,secind));
end

function valueChangedCallback(ndFilaSecInd, src, evt)
    fprintf('Section position spinner value changed to %d.\n', evt.Value);

    ndFilaSecInd.updateValue(evt.Value);
end