function registerSegStepSpin(obj, spin)
    spin.ValueChangedFcn = @(src, evt)(valueChangedCallback(obj.ndSpecSegStep, src, evt));

    comg.Node.output("Set Segment Size for Calculating Spectrum", ...
            @(val)(setSpinValue(spin, val)), ...
            obj.ndSpecSegStep ...
        ).activate();
end

function setSpinValue(spin, val)
    spin.Value = val;
end

function valueChangedCallback(ndSpecSegStep, src, evt)
    fprintf('Segment Size value changed from %d to %d.\n', evt.PreviousValue, evt.Value);
    ndSpecSegStep.updateValue(evt.Value);
end

