function registerTFFilaAutoCenButton(obj, butt)
    butt.ButtonPushedFcn = @(src, evt)(buttonPushedCallback( ...
        obj.ndTFNewFilaPts, obj.ndExtrFilaRect.value, obj.ndExtrFilaPts.value, obj.ndExtrFilaPtLens.value, ...
        obj.ndExtrFilaRMFr.value, obj.ndExtrFilaRMFs.value, obj.ndFilaOutRad.value, src, evt));
    
    comg.Node.output("Enable Auto-Centerization-Button",...
            @(fila_engine, stat_free, stat_foc)(enableComponent(butt, fila_engine, stat_free, stat_foc)), ...
            obj.ndFilaEngn, obj.ndStatTFFree, obj.ndStatTFFoc ...
        ).activate();
end

function enableComponent(component, fila_engine, stat_free, stat_foc)
    flag_enable = fila_engine.inFilamentTuningMode();
    flag_enable = flag_enable && (stat_free || stat_foc);

    component.Enable = flag_enable;
end

function buttonPushedCallback(ndTFNewFilaPts, extr_fila_rect, extr_fila_pts, extr_fila_ptlens, RMFr, RMFs, out_rad, src, evt)
    fprintf("TF Auto Centerize button pushed.\n");

    rect = cenrsz(extr_fila_rect, [41,41,size(extr_fila_rect,3)]);

    secrad = ceil(out_rad * 1.2);
    insec_bias = helix.findFilamentCenter(rect, 'biasrad', 5, 'secrad', secrad);
    intomo_bias = insec_bias(1,:).*RMFr + insec_bias(2,:).*RMFs;
    new_pos = extr_fila_pts + intomo_bias(:, min(size(RMFr, 2), round(extr_fila_ptlens)+1));

    ndTFNewFilaPts.updateValue(new_pos);
end

