function [stpts, edpts, direct, shift_ind] = latticeLines(va, vb, xlim, ylim, ref_pt)

    M = [va(:), vb(:)];
    
    lb_ind = M\[xlim(1)-ref_pt(1); ylim(1)-ref_pt(2)];
    lt_ind = M\[xlim(1)-ref_pt(1); ylim(2)-ref_pt(2)];
    rb_ind = M\[xlim(2)-ref_pt(1); ylim(1)-ref_pt(2)];
    rt_ind = M\[xlim(2)-ref_pt(1); ylim(2)-ref_pt(2)];

    min_x_ind = min([lb_ind(1),lt_ind(1),rb_ind(1),rt_ind(1)]);
    max_x_ind = max([lb_ind(1),lt_ind(1),rb_ind(1),rt_ind(1)]);
    min_y_ind = min([lb_ind(2),lt_ind(2),rb_ind(2),rt_ind(2)]);
    max_y_ind = max([lb_ind(2),lt_ind(2),rb_ind(2),rt_ind(2)]);

    int_list_x = ceil(min_x_ind):floor(max_x_ind);
    int_list_y = ceil(min_y_ind):floor(max_y_ind);
    stpts_ind = [int_list_x;(min_y_ind-1)*ones(1,numel(int_list_x))];
    edpts_ind = [int_list_x;(max_y_ind+1)*ones(1,numel(int_list_x))];
    stpts_ind = [stpts_ind,[(min_x_ind-1)*ones(1,numel(int_list_y));int_list_y]];
    edpts_ind = [edpts_ind,[(max_x_ind+1)*ones(1,numel(int_list_y));int_list_y]];

    direct = [2 * ones(1,numel(int_list_x)), 1 * ones(1,numel(int_list_y))];
    shift_ind = [int_list_x, int_list_y];

    stpts = M*stpts_ind + ref_pt(:);
    edpts = M*edpts_ind + ref_pt(:);

    k = (edpts(2,:)-stpts(2,:))./(edpts(1,:)-stpts(1,:));

    idx = stpts(1,:) < xlim(1);
    stpts(2,idx) = stpts(2,idx) + (xlim(1)-stpts(1,idx)) .* k(idx);
    idx = stpts(1,:) > xlim(2);
    stpts(2,idx) = stpts(2,idx) + (xlim(2)-stpts(1,idx)) .* k(idx);
    stpts(1,:) = max(xlim(1), min(xlim(2), stpts(1,:)));

    idx = edpts(1,:) < xlim(1);
    edpts(2,idx) = edpts(2,idx) + (xlim(1)-edpts(1,idx)) .* k(idx);
    idx = edpts(1,:) > xlim(2);
    edpts(2,idx) = edpts(2,idx) + (xlim(2)-edpts(1,idx)) .* k(idx);
    edpts(1,:) = max(xlim(1), min(xlim(2), edpts(1,:)));


    k = (edpts(1,:)-stpts(1,:))./(edpts(2,:)-stpts(2,:));

    idx = stpts(2,:) < ylim(1);
    stpts(1,idx) = stpts(1,idx) + (ylim(1)-stpts(2,idx)) .* k(idx);
    idx = stpts(2,:) > ylim(2);
    stpts(1,idx) = stpts(1,idx) + (ylim(2)-stpts(2,idx)) .* k(idx);
    stpts(2,:) = max(ylim(1), min(ylim(2), stpts(2,:)));

    idx = edpts(2,:) < ylim(1);
    edpts(1,idx) = edpts(1,idx) + (ylim(1)-edpts(2,idx)) .* k(idx);
    idx = edpts(2,:) > ylim(2);
    edpts(1,idx) = edpts(1,idx) + (ylim(2)-edpts(2,idx)) .* k(idx);
    edpts(2,:) = max(ylim(1), min(ylim(2), edpts(2,:)));

end