function pts = latticePoints(va, vb, xlim, ylim, ref_pt)

    M = [va(:), vb(:)];
    
    % Brief of theory
    % M*ind+ref_pt \in (xlim * ylim);
    % ==> M*ind \in xrange * yrange, where xrange = xlim - ref_pt_x
    % ==> ind \in M\(xrange * yrange)

    lb_ind = M\[xlim(1)-ref_pt(1); ylim(1)-ref_pt(2)];
    lt_ind = M\[xlim(1)-ref_pt(1); ylim(2)-ref_pt(2)];
    rb_ind = M\[xlim(2)-ref_pt(1); ylim(1)-ref_pt(2)];
    rt_ind = M\[xlim(2)-ref_pt(1); ylim(2)-ref_pt(2)];

    % The problem turn to be finding integral poinr in the region
    % surrounded by four points: lb/lt/rb/rt
    
    min_x_ind = min([lb_ind(1),lt_ind(1),rb_ind(1),rt_ind(1)]);
    max_x_ind = max([lb_ind(1),lt_ind(1),rb_ind(1),rt_ind(1)]);
    min_y_ind = min([lb_ind(2),lt_ind(2),rb_ind(2),rt_ind(2)]);
    max_y_ind = max([lb_ind(2),lt_ind(2),rb_ind(2),rt_ind(2)]);

    % all integral points
    [intpt_x, intpt_y] = meshgrid(ceil(min_x_ind):floor(max_x_ind),...
        ceil(min_y_ind):floor(max_y_ind));
    intpt_x = intpt_x(:);
    intpt_y = intpt_y(:);
    intpts = [intpt_x, intpt_y]';

    % determine availability
    intpts_coords = M*intpts + ref_pt(:);
    avail_idx = intpts_coords(1,:) > xlim(1)-1e-5;
    avail_idx = avail_idx & (intpts_coords(1,:) < xlim(2)+1e-5);
    avail_idx = avail_idx & (intpts_coords(2,:) > ylim(1)-1e-5);
    avail_idx = avail_idx & (intpts_coords(2,:) < ylim(2)+1e-5);

    pts = intpts_coords(:, avail_idx);

end