function cyl_coord = ptEul2Cyl(smth_pts, RMF_r, RMF_s, RMF_t, eul_coord)
    % eul_coord: [x;y;z] (3xN)

    if isempty(smth_pts) || isempty(RMF_r) || isempty(RMF_s) || isempty(RMF_t) || isempty(eul_coord)
        cyl_coord = [];
        return;
    end

    [~, base_ind] = min(pdist2(smth_pts', eul_coord'), [], 1);
    diff_vec = eul_coord - smth_pts(:, base_ind);
    M = cat(3, RMF_r(:,base_ind), RMF_s(:,base_ind), RMF_t(:,base_ind));
    v = sum(M .* diff_vec, 1);
    cyl_coord = permute(v,[2,3,1])';
    cyl_coord(3,:) = cyl_coord(3,:) + base_ind - 1;
    
end